const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const authors = sequelize.define(
    'authors',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

bio: {
        type: DataTypes.TEXT,
      
      

      },

website_url: {
        type: DataTypes.TEXT,
      
      

      },

primary_language: {
        type: DataTypes.ENUM,
      
      

        values: [

"uz",


"ru",


"en",


"other"

        ],

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  authors.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity







































//end loop





    db.authors.hasMany(db.file, {
      as: 'photo_images',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.authors.getTableName(),
        belongsToColumn: 'photo_images',
      },
    });


    db.authors.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.authors.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return authors;
};


